{{
The cogOScore functions take care of the upper EEPROM. 
}}
con
  ' size of a descriptor-table entry in bytes
  ENTRY_SIZE    = 20
  ' There is room for 16 entries in the descriptor table
  TAB_SIZE      = 16 * ENTRY_SIZE

obj
  i2c:    "Basic_I2C_Driver"

var
  long tabAddress
  byte numOfEntries

pub init( tbuffer )
  ' read the max. possible number of bytes for the descriptor table
  i2c.Initialize(i2c#BootPin)
  i2c.ReadPage(i2c#BootPin, $a2, $7e00, tbuffer, 512)

  tabAddress := tbuffer
  numOfEntries := byte[ tabAddress + $00b4 + TAB_SIZE + 11 ]
  return numOfEntries

pub setBuffer( tbuffer )
  tabAddress := tbuffer
  numOfEntries := byte[ tabAddress + $00b4 + TAB_SIZE + 11 ]
  return numOfEntries

pub loadDriver( name, version ) : retVal | found, i
  retVal := -1
  found:=0
  if numOfEntries>0
    repeat i from 0 to numOfEntries-1
      if strCmp( name, tabAddress + $00b4 + TAB_SIZE-12 - ENTRY_SIZE*i )
        retVal := -2
        ' here we found the string and have to check the version
        if version == word[ tabAddress + $00b4 + TAB_SIZE-18 - ENTRY_SIZE*i ]
          found:=-1
          quit

  if found
    retVal := i
    i2c.ReadPage(i2c#BootPin, $a2, $800*i , tabAddress+512, 2048)

pri strCmp( adrA, adrB ) | i
  repeat i from 0 to 11
    if byte[ adrA + i ] <> byte[ adrB + i ]
      return 0
    if byte[ adrA + i ] == 0
      return -1
  return -1
  