CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        SDCardPinBase   = 0 ' 16

        VMEM_MAX = 64*1024*1024 - 1
        TEXT_MAX = 32*1024
        BIN_MAX  = 512*16384

        BIN_START = VMEM_MAX - TEXT_MAX - BIN_MAX + 1

dat
name
  byte "testio",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
bom
  file "cmd_testio.bin"
eom
  byte 0
         
obj
   term:  "FullDuplexSerial_NP"
   sd:    "fsrwFemto_NP"
   desc:  "COGdesc"

var
  ' keep both buffers togther, as cogOScore expects it to be continuous
  long buffer[ 128 ]
  long ld_buffer[ 2048 ]
  ' parameter buffer for the NP SDcard driver
  long ioControl[2]
  long start_list, end_list

  long length, size

  ' this is for parsing parameters from the input line
  long par_list[32]
  ' as we allow max. 32 parameters, each bit of type tells
  ' whether the parameter is a string pointer (=1) or a number (=0)
  long par_typ, par_cnt
  
  long opcode
  word tmpkey
  byte key_buffer[128],key_cnt,key_ndone
  byte fname[13]
  byte dirbuf[sd#DIRSIZE] '

pub main | tmp, tmp1, found, long_val, mode, sstart, i, j, k, mult, start_time, stop_time
  ' start the code that knows how to read the driver table
  ' and give it some space ( 512 bytes for directory + 512 longs for driver)
  ' after loading all needed drivers the buffers can be used 
  desc.initDesc( @buffer )
  ' load the FullDuplexSerial in version 1.1
  tmp := desc.loadDriver( @fdserial , $0110 )
  ' when you are sure that the driver exists it can be started right away, otherwise
  ' you should rather check the result
  
  ' run the NP full duplex
  ' first get the address of the communication buffer
  tmp := term.start( term#BOOT_RX, term#BOOT_TX, 0, 57600 )
  ' and then start the code loaded by loadDriver
  term.setCOG( i:=cognew( @ld_buffer, tmp ) )
  'waitcnt( clkfreq*10 + cnt )

  ' wait until any key has been pushed
  tmp:=-1
  repeat while tmp==-1
    term.str( string( "newCogOSSaveBIN",$0d,"== please press key to start ==",$0d ) )
    tmp:=term.rxtime( 1000 )
  term.tx( 0 )
  term.str( string( "newCogOSSaveBIN",$0d ) )

  ' now load the SD driver
  tmp := desc.loadDriver( @sdcard , $0170 )
  sd.start(@ioControl,@ld_buffer)
  i:=cognew( @ld_buffer, @ioControl )

  ' mount the SD Card
  mntSD
  ' and use the OS SWAP-file in slot 0
  sd.vOpenSwap( 0, string( "osswap.sys" ) )

  term.str( string( "Searching the ExecList starting from $" ) )
  term.hex( BIN_START, 8 )
  nl

  sd.vrMemCopy( 0, BIN_START+8, @ld_buffer, 32)
  if strcomp( @ld_buffer, string( "ExecList" ) )
    term.str( string( "found the ExecList!" ) )
    nl
  else
    term.str( string( "ExecList not found!") )
    nl
    sd.vPoke( 0, BIN_START, BIN_START+32 )
    sd.vPoke( 0, BIN_START+4, BIN_START+32 )
    sd.vwMemCopy( 0, BIN_START+8, string( "ExecList" ), 9 )

  start_list := sd.vPeek( 0, BIN_START )
  end_list := sd.vPeek( 0, BIN_START + 4 )

  if (i:=vsearch( start_list, end_list, @name )) == -1
    i:=end_list
    end_list+=32

    if end_list>(VMEM_MAX - TEXT_MAX)
      term.str( string( "Error: No more free slots!" ) )
      repeat
      
    ' create new entry
    sd.vwMemCopy( 0, i, @name, 32 )
    sd.vPoke( 0, BIN_START+4, end_list )
     
  i:=(i-start_list)/32 + 1

  term.str( string("storing binary in slot ") )
  term.dec( i )
  term.str( string(" at address ") )
  term.hex( BIN_START + i*16384, 8 )
  nl

  sd.vwMemCopyNL( 0, BIN_START + i*16384, @bom, @eom-@bom )
    
  sd.vMemFlush( 0 )  
  term.str( string( "done!",$0d ) )

pub vsearch( from_adr, to_adr, str_adr ) | i,j,k 
  k := @ld_buffer
  j:=from_adr
  size := 32
  repeat while j<to_adr
    sd.vrMemCopy( 0, j, k, size )
    if strcomp( k, str_adr )
      return j
    j := j+ size
  return -1

pri nl
  term.tx( $0d )     
pri mntSD | i
  i := (\sd.mount(SDCardPinBase,SDCardPinBase+1,SDCardPinBase+2,SDCardPinBase+3)=>0)
  if !i
    term.str( @sd_nf )
  else
    term.str( @sd_f )
  
dat
  org 0

sdcard        byte      "SDcard",0
fdserial      byte      "FDSerial",0
sd_nf         byte      "SDCard not found!",13,0
sd_f          byte      "SDCard mounted!",13,0
  