CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

  LCDBasePin    = 8
  LEDOnPin      = 15

  SDpinBase = 0

obj
   term:    "CogOS_IO(Term)"
   sd:      "fsrw"
   lcd:     "BenkyLCDdriver"
   'desc:    "COGdesc"
   'driver:  "cogOScoreRAM"
   
pub testxterm 
  sd.mount( SDpinBase )

  term.start(0, 0)
  ' if LEDOnPin is a valid pin number, set to output a 1 (enable LED) 
  if LEDOnPin < 31
    outa[ LEDOnPin ] := 1 
    dira[ LEDOnPin ] := 1

  LCD.start( LCDBasePin,0 )

  LCD.exec( LCD#CMD_INSTR, %00000001 ) ' Clear LCD
  LCD.exec( LCD#CMD_INSTR, %10000000 ) ' this sets the 'cursor' position
  LCD.exec( LCD#CMD_PRINT, string("Xmodem test") )

  msgStrWt( string( "Trying open" ) )   
  sd.popen( string( "recfile.txt") , "w" )

  msgStrWt( string( "Trying receive" ) )
  
  programXmodemReceive
  
  sd.pclose
  msgStrWt( string( "Done!" ) )   
  repeat

dat
num byte 0[11]  
spc byte "                ",0
pt  byte ".",0
oc  byte 0

PUB printDec( val ) | j
  j:=10
  if val>0
    repeat while val<>0
      j--
      num[j]:="0"+val//10
      val:=val/10
  else
    LCD.exec( LCD#CMD_WRITE, "0" )

  LCD.exec( LCD#CMD_PRINT, @num+j )

pub msgDec( dec_val )
  LCD.exec( LCD#CMD_INSTR, %10000000 + $40 )
  printDec( dec_val )
  LCD.exec( LCD#CMD_PRINT, @spc )
  waitcnt( clkfreq*2 + cnt )
    
pub msgStr( str_adr )
  LCD.exec( LCD#CMD_INSTR, %10000000 + $40 )
  LCD.exec( LCD#CMD_PRINT, str_adr )
  LCD.exec( LCD#CMD_PRINT, @spc )

pub msgStrWt( str_adr )
  msgStr( str_adr )
  waitcnt( clkfreq*2 + cnt )
  
pub str

pub out( x )
  if oc == 0
    LCD.exec( LCD#CMD_INSTR, %10000000 + $40 )
    LCD.exec( LCD#CMD_PRINT, @spc )
    LCD.exec( LCD#CMD_INSTR, %10000000 + $40 )
  
  oc:=(oc+1)&15
  LCD.exec( LCD#CMD_PRINT, x )

VAR
   byte XmodemBuffer[132]
   byte validpacket
   word PacketNumber
   byte ErrorCounter
   word i
   byte OnesComplement
   word Checksum
   byte Timeout
   long Filename

PRI programXmodemReceive ' eg XMR MYFILE.TXT
  'ifnot(str.stringCompareCI(string("xmr"), stringPointer))
  '  Filename:=str.tokenizestring(0)                     ' keep tokenizing the stringpointer string to get the filename
  '  vt100.str(string("Receiving filename: "))
  '  vt100.str(Filename)
  '  vt100.out(13)
  '  vt100.out(10)
    msgStrWt(string("Send NAK & wait")) ' only print on local display, not to serial port
    i:=0                                                ' set counter to 0
    term.rxflush                                      ' clear the receive buffer
     repeat while (i < 15 and term.rxavail==0)        ' send 15 NAKs don't make the delay too short
       out(string("."))                                   ' print a . on vga display
       term.tx(21)                                     ' send a NAK to start things off
       pause1ms(1000)                             ' wait 1 second 
       i++
                                                     ' add 1 to i
    if term.rxavail
'
       'i:=\fat.openfile(Filename,"R")                   ' does this file already exist? The \ says to keep going even if there is an error
       'i:=fat.checkerrornumber                          ' 0 if it does exist
       'if i==0                                          ' yes it does exist so delete it
       '  fat.closefile                                  ' close this file
       '  fat.deleteEntry(Filename )                     ' delete any files with this name
         'vt100.str(string("Deleting previous file",13,10))
       'vt100.str(string("Creating file",13,10))     ' print creating new file message
       'fat.openFile(fat.newFile(Filename), "W") 'create a new file   
'
       msgStr(string("Strt transfer"))
       pause1ms(100)                              ' short delay might make "1st packet errors" less likely                        
       errorcounter:=0                                  ' reset error counter
       packetnumber:=1                                   ' packet number 1
      repeat
         validpacket :=255                              ' equals true, set to 0 if any errors further down
         timeout:=0
         repeat while timeout <100                      ' timeout if no byte arrives
           if term.rxavail                              ' is there a byte?
             XmodemBuffer[0]:=term.rx                         ' read in one byte
             timeout:=255                               ' finish the timeout
           else
             pause1ms(1)                          ' wait 1 ms
             timeout++                                  ' add 1 to timeout
        if XmodemBuffer[0] <> 4                         ' finish byte
          'finish:=255                                   ' signifies finish with no errors
          ' else  
          if XmodemBuffer[0] <> 1                       ' not 1 so packet corrupt
            validpacket:=0                              ' invalid packet
            errorcounter++                              ' add one to error counter
            out(string("x"))                              ' a common error on 1st packet so print something short
            'repeat i from 0 to 131                       ' dump what did come in
            '  vt100.hex(xmodembuffer[i],2)
            '  vt100.out(" ")
            pause1ms(500)                          ' small delay
            term.rxflush                               'flush the serial port
            term.tx(21)                                ' send a NAK
            pause1ms(500)                        ' hopefully restart
          else                                          ' 1= a valid start byte for a packet
            i:=1
            timeout:=0                                  ' if times out then packet will be corrupt
            repeat while i<132                         ' includes a timeout if half packet missing
              if term.rxavail                         ' if a byte is available
                XmodemBuffer[i]:=term.rx                    ' read it in
                i++                                       ' and increment
              else
                pause1ms(10)                        ' otherwise, pause a little
                timeout++                                 ' and keep track of the pauses
                if timeout>100                            ' and give up after 1 second total
                  i:=133                                 ' force end if there is a timeout
                  errorcounter++                        ' and add one to error counter
                  out(string("t"))
            packetnumber &= 255                         ' bitwise AND with 255, quicker than repeatedly subtracting 256      
            onescomplement:=255-packetnumber            ' calculate the ones complement
            if packetnumber <> XmodemBuffer[1]
              validpacket:=0                            ' not a valid packet
              errorcounter++
              out(string("p"))
            if XmodemBuffer[2] <> onescomplement            ' ones complement not correct
              validpacket:=0
              errorcounter++
              out(string("o"))                             
            checksum:=0                                 ' calculate the checksum
            repeat i from 3 to 130
               checksum:=checksum+XmodemBuffer[i]

            checksum &= 255                             ' bitwise AND with 255, same as repeatedly subtracting 255
            'repeat while checksum>255                   ' round to under 256
                'checksum:=checksum-256
            if checksum <> XmodemBuffer[131]                   ' checksum not valid
              validpacket:=0
              errorcounter++
              out(string("c"))
            if validpacket == 255                         ' packet is valid so save it
              'fat.writeData(@XmodemBuffer+3,128)
              packetnumber++                             ' increment packet number
              term.tx(6)                                ' send a ACK and wait for the next packet
              out(string("."))                             ' print a . on the screen for each packet
            else
              term.tx(21)                               ' send a NAK as the packet was corrupted
              msgStr(string("NAK"))
              errorcounter++
              msgStr(string("Request packet resend "))       ' increment the error counter
      until errorcounter>10 or xmodembuffer[0]==4 ' too many errors, or 04=the finish byte
      term.tx(6)
      'fat.CloseFile
      if errorcounter==0
        msgStrWt(string("No errors"))
      if errorcounter>0 and errorcounter<11
        msgStrWt(string("File OK some err"))
      if errorcounter>10
        repeat i from 1 to 10
          msgStrWt(string("Cancel "))
          term.tx(18)                                  ' Send Cancel 10 times
          pause1ms(500)
    else
      msgStrWt(string("No txn!"))
      
   return 0

VAR
   long BinaryFileLength
   long BinaryFileCounter

{{    
PRI programXmodemSend(stringPointer) 
   ifnot(str.stringCompareCI(string("xms"), stringPointer))
     Filename:=str.tokenizestring(0)    ' keep tokenizing the stringpointer string
     vt100.str(string("sending file "))
     vt100.str(Filename)
     vt100.str(string(13,10))
     sio.rxflush(0) ' start with clear receive buffer
     fat.openfile(Filename,"R")
     BinaryFileLength:=fat.ListSize
     vt100.dec(BinaryFileLength)   
     vt100.str(string(" bytes",13,10))
     timeout:=0
     i:=0
     vt100.str(string("Waiting for NAK"))               ' wait for NAK from the other end
     repeat while timeout < 15                           ' timeout after 15 seconds
       if sio.rxavail(0)                                 ' anything in the buffer?
         i:=sio.rx(0)                                    ' if yes, collect it
       if i == 21                                          ' exit the loop
         timeout:=100
       delay.pause1ms(1000)                              ' check every 1 second
       vt100.out(".")
       timeout++
 
     if i == 21                                         ' got a NAK so can now send the file
        vt100.str(string(13,10,"Sending file",13,10))
        BinaryFileCounter:=0
        PacketNumber:=1                                 ' packets start at 1
        errorcounter:=0                                 ' keep track of how many errors
        repeat
           delay.pause1ms(1)                            ' tiny delay before send the packet 
           XModemBuffer[0]:=1                           ' SOH ^A  start building a packet
           XmodemBuffer[1]:=PacketNumber                ' PacketNumber
           OnesComplement := 255 - Packetnumber         ' Ones complement
           XmodemBuffer[2]:=OnesComplement              ' ones complement
           PacketNumber++                               ' add one to packet number
           PacketNumber &= 255                          ' if >255 then subtract 255. Bitwise AND with 0000000011111111
           Checksum:=0                                  ' start creating the checksum
           fat.readData(@XmodemBuffer+3,128)            ' get next 128 bytes
           repeat i from 3 to 130
             Checksum:=Checksum+XmodemBuffer[i]         ' create checksum
             BinaryFileCounter++                        ' keep track of total bytes read
           Checksum &= 255                              ' bitwise AND with 0000000011111111
           XmodemBuffer[131]:=Checksum                  ' Store the checksum
           OutputXout                                   ' send the packet
           timeout:=0                                   ' wait for ACK NAK CAN or give up
           i:=0
           repeat while timeout<7                       ' wait 70ms, if nothing, give up
             delay.pause1ms(10)                         ' 10 millisecond pause for other end to do checksum etc
             timeout++                                  ' add one to the timeout counter
             if sio.rxavail(0)                          ' is there a byte?
               i:=sio.rx(0)                             ' get the byte
               timeout:=255                             ' finish waiting
           if i== 6                                     ' got an ACK
             vt100.out(".")                             ' print a . on the screen for a packet
           if i==21                                     ' got a NAK so resend this packet                                             
             vt100.out("x")                             ' print x if an error
             errorcounter++                             ' add one to error counter 
             OutputXout                                 ' send out the packet again
           if i==0 or i==18 or errorcounter>10          ' timeout or Cancel so give up sending
             BinaryFileCounter:=BinaryFileLength+500    ' so stops sending, definitely more than a packet
           
        until BinaryFileCounter>BinaryFileLength-1      ' 256 bytes = 2 packets so finish when gets to 255
     delay.pause1ms(10)                                 ' possibly not needed
     sio.tx(0,4)                                        ' send a 04 to finish up
     fat.CloseFile                                      ' close the file, whether sent it or not
    abort 0
PUB OutputXout                                          ' send the packet (called from two places above)
    repeat i from 0 to 131
      sio.tx(0,XmodemBuffer[i])
}}

CON
  
  _10us = 1_000_000 /        10                         ' Divisor for 10 us
  _1ms  = 1_000_000 /     1_000                         ' Divisor for 1 ms
  _1s   = 1_000_000 / 1_000_000                         ' Divisor for 1 s

VAR
  long clkcycles

PUB pause1ms(period)

'' Pause execution for period (in units of 1 ms).

  clkcycles := ((clkfreq / _1ms * period) - 4296) #> 381     ' Calculate 1 ms time unit
  waitcnt(clkcycles + cnt)                                   ' Wait for designated time